;
;       Another Brick in the wall by Andrew Jones
;
;       Computing Today June 1980
;
;       Press '0' to shoot
;

#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Disp    .equ    0D00h
Ammo    .equ    0FFh

        .org    0F12h

Shoot:  ldi     High(Disp)
        xpah    1
        ldi     0Fh
        xpah    2
        ldi     0C0h
        xpal    2
        ldi     6                       ; set ammo
        st      Ammo(2)
        ldi     7Fh                     ; set up wall
        st      0(2)
        ldi     49h
        st      1(2)
        st      2(2)
        st      3(2)
        st      4(2)
        st      5(2)
        st      6(2)
        st      7(2)
        ldi     0                       ; place Cursor
        xae
        nop
Set:    ldi     14                      ; loop 14 times
        st      DatPtr(LC1+1)
Loop:   dld     DatPtr(LC1+1)
        jz      Move
        ldi     0                       ; set up displacements
        st      DatPtr(DC1+1)
        ldi     74h
        st      DatPtr(DC2+1)
LC1:    ldi     00h
        dly     05                      ; slow cursor
DC2:    ld      0(0)                    ; load & display wall segment
DC1:    st      0(1)
        ild     DatPtr(DC2+1)
        ild     DatPtr(DC1+1)
        xri     9                       ; end of loop
        jnz     LC1
        ild     0(1)                    ; key pressed
        nop
        nop
        jz      Loop                    ; if not goto loop
        ld      80h(2)                  ; load using E as ofset
        xri     36h                     ; how many bricks left
        jz      Win                     ; none, goto win
        xri     8
        jz      One
        xri     40h
        jz      Two
        ldi     7Eh                     ; three remove one
        st      80h(2)                  ; save it
        jmp     Next
Two:    ldi     3Eh
        st      80h(2)
        jmp     Next
One:    ldi     36h
        st      80h(2)
Next:   dld     Ammo(2)
        jz      Lose
Move:   ld      80h(2)
        xri     36h
        st      80h(2)
        lde
        adi     1
        xae
        lde
        nop
        xri     8
        jnz     Cont
        ldi     0
        xae
        nop
Cont:   ld      80h(2)
        xri     36h
        st      80h(2)
        dly     7Fh
        jmp     Set
Lose:   ldi     38h                     ; display L
        st      (1)
        jmp     Lose
Win:    ldi     6Dh                     ; display S
        st      (1)
        jmp     Win
        .end

